Package ru.bitel.bgbilling.kernel.tariff.option.common.service

# Interface TariffOptionService

public interface TariffOptionService

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `configOption()`
  `void`
  `contractTariffOptionActivate(ContractTariffOptionData contractTariffOptionData)`
  Активирование тарифной опции для договора.
  `int`
  `contractTariffOptionActivateWhithSum(ContractTariffOptionData contractTariffOptionData)`
  Активирование тарифной опции для договора, с суммой расхода.
  `void`
  `contractTariffOptionDeactivate(int contractId, int contractOptionId)`
  Деактивация тарифной опции.
  `void`
  `contractTariffOptionDelete(int contractId, int id, boolean customer)`
  `List<ContractTariffOption>`
  `contractTariffOptionHistory(int contractId, Date date, boolean web)`
  Получение списка тарифных опций договора, период действия которых закончился по отношении к указанной дате.
  `List<ContractTariffOption>`
  `contractTariffOptionList(int contractId, Date date)`
  Получение тарифных опций период активности которых пересекается или еще не наступил с указанной датой.
  Т.е. активных тарифных опций.
  `List<ContractTariffOption>`
  `contractTariffOptionListWeb(int contractId, Date date, List<ContractTariffOption> contractTariffOptionList)`
  Получение тарифных опций период активности которых пересекается или еще не наступил с указанной датой для web.
  Т.е. активных тарифных опций.
  `void`
  `contractTariffOptionReactivate(int contractId, int contractOptionId)`
  Реактивация тарифной опции.
  `TariffOptionActivateMode`
  `tariffOptionActivateModeGet(int optionId, int modeId)`
  Вернет режим активации.
  `List<TariffOptionActivateMode>`
  `tariffOptionActivateModeList(int optionId, Date date)`
  `void`
  `tariffOptionDelete(int id)`
  Удаление тарифной опции
  `TariffOption`
  `tariffOptionGet(int id)`
  Получение тарифной опции по коду.
  `List<TariffOption>`
  `tariffOptionList(int groupId, boolean showNoUsed)`
  Получение списка тарифных опций.
  `List<TariffOption>`
  `tariffOptionListAvailable(int contractId, Date date, List<ContractTariffOption> currentContractOptionList, boolean onlyAvailable, boolean web, boolean showNoUsed)`
  Получение списка тарифных опций на указанную дату, c заполнением поля enable c учетом тарифов и групп договоров.
  `List<IdTitle>`
  `tariffOptionTitles(int groupId, boolean showNoUsed)`
  `void`
  `tariffOptionUpdate(TariffOption tariffOption)`
  Обновление тарифной опции
  `List<TariffOption>`
  `tariffOptionWebList(int contractId, Date date, List<TariffOption> fullOptionList)`
  Опции, которые можно показывать в веб.

- ## Method Details

  - ### tariffOptionGet

    TariffOption tariffOptionGet(int id) throws ru.bitel.bgbilling.common.BGException
    Получение тарифной опции по коду.
    Parameters:
      `id` - код тарифной опции
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### tariffOptionTitles

    List<IdTitle> tariffOptionTitles(int groupId, boolean showNoUsed) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### tariffOptionList

    List<TariffOption> tariffOptionList(int groupId, boolean showNoUsed) throws ru.bitel.bgbilling.common.BGException
    Получение списка тарифных опций.
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### tariffOptionWebList

    List<TariffOption> tariffOptionWebList(int contractId, Date date, List<TariffOption> fullOptionList) throws ru.bitel.bgbilling.common.BGException
    Опции, которые можно показывать в веб.
    Parameters:
      `contractId` -
      `date` -
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### tariffOptionListAvailable

    List<TariffOption> tariffOptionListAvailable(int contractId, Date date, List<ContractTariffOption> currentContractOptionList, boolean onlyAvailable, boolean web, boolean showNoUsed) throws ru.bitel.bgbilling.common.BGException
    Получение списка тарифных опций на указанную дату, c заполнением поля enable c учетом тарифов и групп договоров.
    Parameters:
      `contractId` -
      `date` -
      `onlyAvailable` -
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### tariffOptionUpdate

    void tariffOptionUpdate(TariffOption tariffOption) throws ru.bitel.bgbilling.common.BGException
    Обновление тарифной опции
    Parameters:
      `tariffOption` - опция
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### tariffOptionDelete

    void tariffOptionDelete(int id) throws ru.bitel.bgbilling.common.BGException
    Удаление тарифной опции
    Parameters:
      `id` - код опции
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### tariffOptionActivateModeList

    List<TariffOptionActivateMode> tariffOptionActivateModeList(int optionId, Date date) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### tariffOptionActivateModeGet

    TariffOptionActivateMode tariffOptionActivateModeGet(int optionId, int modeId) throws ru.bitel.bgbilling.common.BGException
    Вернет режим активации.
    Parameters:
      `optionId` - ид тарифной опции.
      `modeId` - ид режима активации тарифной опции.
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffOptionList

    List<ContractTariffOption> contractTariffOptionList(int contractId, Date date) throws ru.bitel.bgbilling.common.BGException
    Получение тарифных опций период активности которых пересекается или еще не наступил с указанной датой.
    Т.е. активных тарифных опций.
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffOptionListWeb

    List<ContractTariffOption> contractTariffOptionListWeb(int contractId, Date date, List<ContractTariffOption> contractTariffOptionList) throws ru.bitel.bgbilling.common.BGException
    Получение тарифных опций период активности которых пересекается или еще не наступил с указанной датой для web.
    Т.е. активных тарифных опций.
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffOptionActivate

    void contractTariffOptionActivate(ContractTariffOptionData contractTariffOptionData) throws ru.bitel.bgbilling.common.BGException
    Активирование тарифной опции для договора.
    Parameters:
      `contractId` - договор
      `optionId` - опций
      `modeId` - режим активации опции
    Throws:
      `ru.bitel.bgbilling.common.BGException` - если активация невозможна или произошла ошибка

  - ### contractTariffOptionActivateWhithSum

    int contractTariffOptionActivateWhithSum(ContractTariffOptionData contractTariffOptionData) throws ru.bitel.bgbilling.common.BGException
    Активирование тарифной опции для договора, с суммой расхода.
    Parameters:
      `contractId` - договор
      `optionId` - опций
      `modeId` - режим активации опции
      `chargeSum` - сумма расхода
    Returns:
      ид расхода договора
    Throws:
      `ru.bitel.bgbilling.common.BGException` - если активация невозможна или произошла ошибка

  - ### contractTariffOptionDeactivate

    void contractTariffOptionDeactivate(int contractId, int contractOptionId) throws ru.bitel.bgbilling.common.BGException
    Деактивация тарифной опции.
    Parameters:
      `contractId` - договор
      `contractOptionId` - код активированной тарифной опции
    Throws:
      `ru.bitel.bgbilling.common.BGException` - если деактивация невозможна или произошла ошибка

  - ### contractTariffOptionReactivate

    void contractTariffOptionReactivate(int contractId, int contractOptionId) throws ru.bitel.bgbilling.common.BGException
    Реактивация тарифной опции.
    Parameters:
      `contractId` - договор
      `contractOptionId` - код деактивированной тарифной опции
    Throws:
      `ru.bitel.bgbilling.common.BGException` - если реактивация невозможна или произошла ошибка

  - ### contractTariffOptionHistory

    List<ContractTariffOption> contractTariffOptionHistory(int contractId, Date date, boolean web) throws ru.bitel.bgbilling.common.BGException
    Получение списка тарифных опций договора, период действия которых закончился по отношении к указанной дате.
    Parameters:
      `contractId` - договор
      `date` - дата
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### contractTariffOptionDelete

    void contractTariffOptionDelete(int contractId, int id, boolean customer) throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`

  - ### configOption

    String configOption() throws ru.bitel.bgbilling.common.BGException
    Throws:
      `ru.bitel.bgbilling.common.BGException`